'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2007
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
Imports DotNetNuke.Entities.Modules

Namespace DotNetNuke.Modules.MarketShare

    Partial Class Edit

        Inherits DotNetNuke.Entities.Modules.PortalModuleBase

#Region "Event Handlers"

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                If Not Page.IsPostBack Then

                    If ModuleId = -1 Then
                        ' invoked externally
                        If Not Request.QueryString("marketshareid") Is Nothing Then
                            txtMarketShare.Text = Request.QueryString("marketshareid").ToString
                            UI.Skins.Skin.AddModuleMessage(Me, Services.Localization.Localization.GetString("MarketShare.Message", Me.LocalResourceFile), Skins.Controls.ModuleMessage.ModuleMessageType.YellowWarning)
                        End If
                    Else
                        ' get module settings
                        txtMarketShare.Text = Entities.Portals.PortalSettings.GetSiteSetting(PortalId, "MarketShareID")
                    End If

                End If
            Catch exc As Exception
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        Private Sub cmdUpdate_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdUpdate.Click
            Try
                If Page.IsValid Then
                    ' save module settings
                    Dim objModules As New ModuleController
                    Entities.Portals.PortalSettings.UpdateSiteSetting(PortalId, "MarketShareID", txtMarketShare.Text)
                    SynchronizeModule()
                    Response.Redirect(NavigateURL())
                End If
            Catch exc As Exception
                ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        Protected Sub cmdCancel_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdCancel.Click

            Response.Redirect(NavigateURL())

        End Sub

        Protected Sub cmdMarketShare_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdMarketShare.Click

            If Services.Localization.Localization.GetString("cmdMarketShare.URL", Me.LocalResourceFile) <> "" Then
                UrlUtils.OpenNewWindow(Services.Localization.Localization.GetString("cmdMarketShare.URL", Me.LocalResourceFile))
            End If

        End Sub

#End Region

    End Class

End Namespace
