-- phpMyAdmin SQL Dump
-- version 2.11.5-rc1
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Mar 12, 2008 at 12:27 PM
-- Server version: 5.0.45
-- PHP Version: 5.2.5

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Database: `phpst`
--

-- --------------------------------------------------------

--
-- Table structure for table `tickets_answers`
--

CREATE TABLE IF NOT EXISTS `tickets_answers` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id` int(32) unsigned NOT NULL default '0',
  `ticket_id` int(32) unsigned NOT NULL default '0',
  `body` text NOT NULL,
  `timestamp` int(16) unsigned NOT NULL default '0',
  `rating` int(1) unsigned NOT NULL default '0',
  `subject` varchar(64) NOT NULL default '',
  UNIQUE KEY `id` (`id`),
  KEY `user_id` (`user_id`),
  KEY `ticket_id` (`ticket_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tickets_answers`
--


-- --------------------------------------------------------

--
-- Table structure for table `tickets_departments`
--

CREATE TABLE IF NOT EXISTS `tickets_departments` (
  `id` int(16) NOT NULL auto_increment,
  `name` varchar(64) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `status` enum('Active','Suspended') NOT NULL default 'Active',
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tickets_departments`
--

INSERT INTO `tickets_departments` (`id`, `name`, `description`, `status`) VALUES
(1, 'Administration', '', 'Active');

-- --------------------------------------------------------

--
-- Table structure for table `tickets_department_users`
--

CREATE TABLE IF NOT EXISTS `tickets_department_users` (
  `id` int(16) unsigned NOT NULL auto_increment,
  `department_id` int(16) unsigned NOT NULL default '0',
  `user_id` int(16) unsigned NOT NULL default '0',
  UNIQUE KEY `id` (`id`),
  KEY `department_id` (`department_id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tickets_department_users`
--

INSERT INTO `tickets_department_users` (`id`, `department_id`, `user_id`) VALUES
(1, 1, 1);

-- --------------------------------------------------------

--
-- Table structure for table `tickets_history_log`
--

CREATE TABLE IF NOT EXISTS `tickets_history_log` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `message` text NOT NULL,
  `type` varchar(64) NOT NULL default '',
  `priority` enum('1','2','3','4','5') NOT NULL default '1',
  `user_id` int(16) unsigned NOT NULL default '0',
  `file` text NOT NULL,
  `line` varchar(64) NOT NULL default '',
  `ip` varchar(16) NOT NULL default '',
  `referer` varchar(255) NOT NULL default '',
  `timestamp` int(12) unsigned NOT NULL default '0',
  UNIQUE KEY `id` (`id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tickets_history_log`
--


-- --------------------------------------------------------

--
-- Table structure for table `tickets_options`
--

CREATE TABLE IF NOT EXISTS `tickets_options` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `value` varchar(32) NOT NULL default '',
  `changed` int(16) unsigned NOT NULL default '0',
  `type` varchar(16) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `changed` (`changed`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4 ;

--
-- Dumping data for table `tickets_options`
--

INSERT INTO `tickets_options` (`id`, `name`, `value`, `changed`, `type`) VALUES
(1, 'OPTION_EMAIL_MODS_WHEN_NEW_TICKET', '1', 1123815378, 'boolean'),
(2, 'OPTION_EMAIL_CLIENT_WHEN_NEW_ANSWER', '1', 1123815378, 'boolean'),
(3, 'OPTION_RECENT_TICKETS_DAYS', '7', 1124320692, 'integer');

-- --------------------------------------------------------

--
-- Table structure for table `tickets_tickets`
--

CREATE TABLE IF NOT EXISTS `tickets_tickets` (
  `id` int(5) unsigned NOT NULL auto_increment,
  `user_id` int(16) unsigned NOT NULL,
  `subject` varchar(50) NOT NULL default '',
  `timestamp` bigint(10) unsigned NOT NULL default '0',
  `status` set('Open','Closed') NOT NULL default 'Open',
  `urgency` set('1','2','3','4') NOT NULL default '1',
  `body` text NOT NULL,
  `department_id` int(16) unsigned default NULL,
  PRIMARY KEY  (`id`),
  KEY `user_id` (`user_id`),
  KEY `department_id` (`department_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tickets_tickets`
--


-- --------------------------------------------------------

--
-- Table structure for table `users`
--

CREATE TABLE IF NOT EXISTS `users` (
  `id` int(16) unsigned NOT NULL auto_increment,
  `username` varchar(16) character set latin1 collate latin1_bin NOT NULL default '',
  `password` varchar(32) character set latin1 collate latin1_bin NOT NULL default '',
  `name` varchar(30) character set latin1 collate latin1_bin NOT NULL,
  `email` varchar(150) character set latin1 collate latin1_bin NOT NULL default '',
  `timestamp` int(16) NOT NULL default '0',
  `admin` enum('Admin','Mod','Client') NOT NULL default 'Mod',
  UNIQUE KEY `ID` (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `users`
--

INSERT INTO `users` (`id`, `username`, `password`, `name`, `email`, `timestamp`, `admin`) VALUES
(1, 'admin', '$ADMIN_PASS', 'Administrator', '$WEBSITE_OWNEREMAIL', 1205306786, 'Admin');
