<?php

error_reporting(0);

// +----------------------------------------------------------------------------------+
// | WebCards Version 1.1 - A powerful, easy to configure e-card system               |
// | Copyright (C) 2003 - 2006  Chris Charlton (corbyboy@hotmail.com)                 |
// |                                                                                  |
// |     This program is free software; you can redistribute it and/or modify         |
// |     it under the terms of the GNU General Public License as published by         |
// |     the Free Software Foundation; either version 2 of the License, or            |
// |     (at your option) any later version.                                          |
// |                                                                                  |
// |     This program is distributed in the hope that it will be useful,              |
// |     but WITHOUT ANY WARRANTY; without even the implied warranty of               |
// |     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                |
// |     GNU General Public License for more details.                                 |
// |                                                                                  |
// |     You should have received a copy of the GNU General Public License            |
// |     along with this program; if not, write to the Free Software                  |
// |     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    |
// |                                                                                  |
// | Authors: Chris Charlton <chris.charlton@gmail.com>                               |
// | Official Homepage: http://www.mywebcards.net                                     |
// | Project Homepage: http://www.sourceforge.net/projects/webcards                   |
// +----------------------------------------------------------------------------------+
//

/*-----------------------------------------------
  USER CONFIGURABLE ELEMENTS
 ------------------------------------------------*/
 
// Do you want to check admin IP addresses?
// This can causes problems if your IP address changes whilst you are online
// bool 1 or 0

$check_ip = 1;

// Use output buffering in the ACP?
// bool 1 or 0

$buffer_acp = 1;
 
/*-----------------------------------------------
  NO USER EDITABLE SECTIONS BELOW
 ------------------------------------------------*/

/*-----------------------------------------------
  ENSURE CONTENT CANNOT BE ACCESSED DIRECTLY
 ------------------------------------------------*/
define("LOADED", 1);

/*-----------------------------------------------
  STRIP SLASHES FROM OUTPUT
 ------------------------------------------------*/
set_magic_quotes_runtime(0);

/*-----------------------------------------------
  IF WE ARE NOT IN SAFE MODE THEN ATTEMPT TO REMOVE SCRIPT TIME LIMIT
 ------------------------------------------------*/
if((bool) @ini_get('safe_mode') == 0 && function_exists("set_time_limit") == 1)
{
	@set_time_limit(0);
}


/*-----------------------------------------------
  REQUIRE CONFIGURATION SETTINGS
 ------------------------------------------------*/
require_once "./config.php";


/*-----------------------------------------------
  REQUIRE GLOBAL FUNCTIONS FILE
 ------------------------------------------------*/
require_once "./source/functions.php";


/*-----------------------------------------------
  BEGIN OUTPUT BUFFERING
 ------------------------------------------------*/
if($buffer_acp == 1)
{
	ob_start("ob_gzhandler");
}


/*-----------------------------------------------
  REQUIRE SPECIFIC LANG FILE
 ------------------------------------------------*/
$ad_lang_cookie = $_COOKIE['temp_ad_lang'];

if(!is_dir($conf['dir'] . "lang/" . $ad_lang_cookie) || !isset($_COOKIE['temp_ad_lang']))
{
	$ad_lang_cookie = "English";
}

if(isset($_GET['act']) && file_exists("./lang/" . $ad_lang_cookie . "/admin/ad_" . $_GET['act'] . ".php"))
{
	require_once "./lang/" . $ad_lang_cookie . "/admin/ad_" . $_GET['act'] . ".php";
}
else
{
	require_once "./lang/" . $ad_lang_cookie . "/admin/ad_misc.php";
}
	require_once "./lang/" . $ad_lang_cookie . "/global.php";
	require_once "./lang/" . $ad_lang_cookie . "/admin/ad_index.php";


/*-----------------------------------------------
  REQUIRE DB DRIVER
 ------------------------------------------------*/
if(!file_exists("./source/drivers/" . $conf['db_driver'] . ".php"))
{
	die("Unable to include the driver file. Please manually check your database settings and folder names");
}
require_once "./source/drivers/" . $conf['db_driver'] . ".php";


/*-----------------------------------------------
  ATTEMPT DATABASE CONNECTION
 ------------------------------------------------*/
$DB = new DB($conf['dbhost'], $conf['dbuser'], $conf['dbpass'], $conf['dbname']);
if (!$DB->connect())
{
	die("Fatal error!<br /><br />Unable to connect to the database.<br />Check your database settings in the configuration section. Ensure that database is switched on.");
}

if(!isset($_GET['s']) || $_GET['act'] == "login")
{
	require_once "./source/ad_login.php";
}

/*-----------------------------------------------
  PROGRAM START
 ------------------------------------------------*/



$need_to_login = 1;
//By default, admin must login

	if (!isset($_GET['s']) && $_GET['act']!="login")
	{
		output(show_login($lang['no_ad_sess_found']));
		// Login if no admin session found
	}
	else if(isset($_GET['s']))
	{
		/*--------------------------------------
		 CHECK IF THE ADMIN SESSION EXISTS IN DATABASE
		---------------------------------------*/
		if (!$DB->query("SELECT * FROM `" . $conf['dbprefix'] . "admin` WHERE session=\"" . escape_string($_GET['s']) . "\""))
		{
			die(error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']));
		}
		if ($DB->num_rows() <= 0)
		{
			output(show_login($lang['ad_sess_no_exist']));
			$need_to_login = 1;
		}
		else
		{
			$ad_data_row = $DB->fetch_array();

			define("AD_USER_NAME", $ad_data_row['user']);
			define("AD_USER_ID", $ad_data_row['ad_id']);
			define("AD_BASE", $ad_data_row['base']);
			define("AD_LANG", $ad_data_row['lang']);
			define("AD_TIME_ADJ", $ad_data_row['time_adj']);

			/*-----------------------------------------------
 			 CHECK THE USER IP AGAINST WHAT WE HAVE STORED?
 			------------------------------------------------*/
			if($check_ip == 1)
			{
				if ($ad_data_row['ip'] != getip())
				{
					output(show_login($lang['bad_ad_ip']));
					$need_to_login = 1;
					// Check the current IP against the one stored in the database
				}
			}

			/*-----------------------------------------------
 			 CHECK WHEN THE USER LOGGED IN
 			------------------------------------------------*/
			if (time() > $ad_data_row['login_time'] + 60*60*2)
			{
				output(show_login($lang['ad_sess_expired']));
				$need_to_login = 1;
			}

			/*-----------------------------------------------
 			 CHECK IF THE USER HAS AT LEAST THE CORRECT COOKIE IDS
 			------------------------------------------------*/
			if(!isset($_COOKIE['admin_id']))
			{
				output(show_login($lang['admin_cookie_error']));
			}

			/*-----------------------------------------------
 			 NOW CHECK IF THE ADMIN ID MATCHES THAT IN THE DATABASE
 			------------------------------------------------*/
			if($ad_data_row['id'] != $_COOKIE['admin_id'])
			{
				output(show_login($lang['admin_cookie_id_error']));
			}


			else
			{
				$need_to_login = 0;
			}
			
		}
	}

	if ($_GET['act'] == "index")
	{
		$to_do = main();
	}

	if($conf['auto_expire'] == "y")
	{
		if($_GET['act'] != "toolbox" && $_GET['what'] != "expirer")
		{
			expire();
		}
	}

/*-----------------------------------------------
  REQUIRE SPECIFIC SOURCE FILE
 ------------------------------------------------*/

if(isset($_GET['act']) && isset($_GET['s']) && file_exists("./source/ad_" . $_GET['act'] . ".php") && $_GET['act'] != "index")
{
	require_once "./source/ad_" . $_GET['act'] . ".php";
}


	

function output($what)
{
global $_GET, $conf, $need_to_login, $cpy, $to_do, $DB, $time, $lang;

$what = isset($what) ? $what : $to_do;

//Initialise array to decide when to output footer and copyright
$no_footer = array("left", "view_email", "view_image");
$no_cpy = array("left");


	if (isset($_GET['act']) || $need_to_login == "1")
	{
		if(!in_array($_GET['what'], $no_footer))
		{
			$stats = get_stats("a");
		}
		else
		{
			// Here we can hide the debug stats
			$start_hide_debug = "<!--";
			$end_hide_debug = "-->";
		}

		if(!$fp = fopen("./templates/admin/template.html", "r"))
		{
			die(error($lang['cannot_open_file'] . "<b>templates/admin/template.html</b>", $lang['check_file_exists'] . "|" . $lang['check_file_perms']));
		}
		$data = fread($fp, filesize("./templates/admin/template.html"));

	}

	$nav = ($need_to_login == 1 || $_GET['act'] == "login") ? "&nbsp;" : parse_basic_admin_template("./templates/admin/admin_left.html");

	$script_output = preg_replace("/{{admin_content}}/i", $what, $data);
	$script_output = preg_replace("/{{nav}}/i", $nav, $script_output);
	$script_output = preg_replace("/{{onload_stuff}}/i", $onload_stuff, $script_output);
	$script_output = preg_replace("/{{start_hide_debug}}/i", $start_hide_debug, $script_output);
	$script_output = preg_replace("/{{end_hide_debug}}/i", $end_hide_debug, $script_output);
	$script_output = preg_replace("/{{admin_script}}/i", $conf['admin_script'], $script_output);
	$script_output = preg_replace("/{{sess}}/i", $_GET['s'], $script_output);
	$script_output = preg_replace("/{{charset}}/i", $lang['charset'], $script_output);


	in_array($_GET['what'], $no_cpy) ? '' : $stats['get_post_stats'] .= $cpy;

	$script_output = preg_replace("/{{ad_debug_stats}}/i", $stats['debug_stats'], $script_output);
	$script_output = preg_replace("/{{ad_sql_stats}}/i", $stats['sql_stats'], $script_output);
	$script_output = preg_replace("/{{ad_get_post_stats}}/i", $stats['get_post_stats'], $script_output);

	//Add language variables
	$script_output = preg_replace("/\|\|(\w+)\|\|/ie", "stripslashes(\$lang['\$1'])", $script_output);
	echo $script_output;
	exit();
}

//If we have made it all the way to the end without any errors, output the final response
output($to_do);

?>