<?php

// +----------------------------------------------------------------------------------+
// | WebCards Version 1.1 - A powerful, easy to configure e-card system               |
// | Copyright (C) 2003 - 2006  Chris Charlton (corbyboy@hotmail.com)                 |
// |                                                                                  |
// |     This program is free software; you can redistribute it and/or modify         |
// |     it under the terms of the GNU General Public License as published by         |
// |     the Free Software Foundation; either version 2 of the License, or            |
// |     (at your option) any later version.                                          |
// |                                                                                  |
// |     This program is distributed in the hope that it will be useful,              |
// |     but WITHOUT ANY WARRANTY; without even the implied warranty of               |
// |     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                |
// |     GNU General Public License for more details.                                 |
// |                                                                                  |
// |     You should have received a copy of the GNU General Public License            |
// |     along with this program; if not, write to the Free Software                  |
// |     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    |
// |                                                                                  |
// | Authors: Chris Charlton <chris.charlton@gmail.com>                               |
// | Official Homepage: http://www.mywebcards.net                                     |
// | Project Homepage: http://www.sourceforge.net/projects/webcards                   |
// +----------------------------------------------------------------------------------+
//


/*-----------------------------------------------
  ENSURE CONTENT CANNOT BE ACCESSED DIRECTLY
 ------------------------------------------------*/
define("LOADED", 1);

//First of all, if lock.cgi doesn't exist we must exit
if(!file_exists("lock.cgi"))
{
	die("The program is not properly installed and has been halted as a precaution. Please contact the webmaster.");
}

require "./config.php";
require "./source/functions.php";


/*-----------------------------------------------
  REQUIRE LANGUAGE FILES
 ------------------------------------------------*/

if(isset($_COOKIE['wc_lang']))
{
	$lang_dir = $_COOKIE['wc_lang'];
}

else
{
	$lang_dir = $conf['default_pub_lang'];
}

if($conf['allow_langs'] == "n") //If changing languages is disabled the user must use the default language
{
	$lang_dir = $conf['default_pub_lang'];
}


$lang_dir = is_dir($conf['dir'] . "lang/" . $lang_dir) ? $lang_dir : "English";

	require_once "./lang/" . $lang_dir . "/index.php";
	require_once "./lang/" . $lang_dir . "/global.php";


/*-----------------------------------------------
  REQUIRE DB DRIVER
 ------------------------------------------------*/
if(!file_exists("./source/drivers/" . $conf['db_driver'] . ".php"))
{
	die("Unable to include the driver file. Please manually check your database settings and folder names");
}
require_once "./source/drivers/" . $conf['db_driver'] . ".php";

if($conf['buffer'] == "y")
{
	ob_start("ob_gzhandler");
}

$DB = new DB($conf['dbhost'], $conf['dbuser'], $conf['dbpass'], $conf['dbname'], false);
if (!$DB->connect())
{
	error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
}
//Connect to the DB

if(check_ip(getip()))
{
	output($conf['ban_message']);
}
//Die if IP address is banned

	if(isset($_GET['act']))
	{
		switch($_GET['act'])
		{
			case 'form':
			$to_do = parse_template();
			break;
			case 'search':
			$to_do = choose_image_template("", "yes");
			break;
			case 'adv_search':
			$to_do = adv_search_form();
			break;
			case 'do_adv_search':
			$to_do = choose_image_template("", "yes");
			break;
			case 'preview':
			$to_do = preview();
			break;
			case 'send_card':
			$to_do = add_n_send();
			break;
			case 'view_stats':
			$to_do = view_stats_page();
			break;
			case 'browse_cat':
			$to_do = choose_image_template();
			break;
			case 'prefs':
			$to_do = set_prefs();
			break;


			case 'do_pickup':
			$to_do = attempt_to_pickup();
			break;

			case 'show_resend_form':
			$to_do = show_resend_form();
			break;

			case 'resend':
			$to_do = do_resend();
			break;

			case 'pickup':
			$to_do = show_pickup_form();
			break;

			default:
			$to_do = view_stats_page();
			break;
		}
	}
	else
	{
		$to_do = view_stats_page();
	}

	if($conf['auto_expire'] == "y")
	{
		expire();
	}

function view_stats_page($messages="")
{
global $conf, $DB, $lang, $page_title;

	if (!$DB->query("SELECT id, title, description FROM " . $conf['dbprefix'] . "categories ORDER by title ASC"))
	{
		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
	}

	$search_box = "<select name=\"search_cat\">\n<option value=\"all\">" . $lang['all_cats'] . "</option>";
	$cat_list = "<tr><td align=\"left\"><img src=\"./site_images/small_arrow.gif\" alt=\"nav\" title=\"nav\" /></td><td align=\"left\"><span class=\"cat_list\"><a href=\"" . $conf['script'] . "?act=browse_cat\"><b>" . $lang['all_cats'] . "</b></a></span><br /></td></tr>\n";

	while($row=$DB->fetch_array())
	{
		$search_box .= "<option value=\"" . $row['id'] . "\">" . $row['title'] . "</option>";
		$cat_list .= "<tr><td align=\"left\"><img src=\"./site_images/small_arrow.gif\" alt=\"nav\"  title=\"nav\" /></td><td align=\"left\"><span class=\"cat_list\"><a href=\"" . $conf['script'] . "?act=browse_cat&amp;cat=" . $row['id'] . "\">" . $row['title'] . "</a></span><br /></td></tr>\n";
	}

	$search_box .= "</select>";

	//If it has not been set in the ACP, set the number of new and popular images displayed to 6
	$num_new_pop_imgs = isset($conf['new_pop_imgs']) ? $conf['new_pop_imgs'] : 6;

	if (!$DB->query("SELECT * FROM " . $conf['dbprefix'] . "images ORDER by id DESC LIMIT 0," . $num_new_pop_imgs . ""))
	{
		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
	}

	//Define
	$new_images = "";

	while($row=$DB->fetch_array())
	{
		$new_images .= "<br />";

		$click_img ="n";
		$click_img = getMacro(getExt($row['thumb']), "click_img");

		if($click_img =="y")
		{
			$new_images .= "<a href=\"" . $conf['script'] . "?act=form&amp;pic=" . $row['id'] . "\">";
		}

		$new_images .= getMacro(getExt($row['thumb']), "macro");

		if($click_img =="y")
		{
			$new_images .= "</a>";
		}

		$new_images .= "<br />";

		$new_images .= "<a href=\"" . $conf['script'] . "?act=form&amp;pic=" . $row['id'] . "\">" . $row['name'] . "</a><br />";
		$new_images = preg_replace("/{{name}}/i", $row['name'], $new_images);
		
		//It is important to set the width and height variables to 0 each time or they will be reused between images
		$width_thumb = "";
		$height_thumb = "";
		if($row['width_thumb'] != "" && $row['width_thumb'] != "0" && $row['width_thumb'] != "NULL")
		{
			$width_thumb = "width=\"" . $row['width_thumb'] . "\"";
		}
		if($row['height_thumb'] != "" && $row['height_thumb'] != "0" && $row['height_thumb'] != "NULL")
		{
			$height_thumb = "height=\"" . $row['height_thumb'] . "\"";
		}
		$new_images = preg_replace("/{{width}}/i", $width_thumb, $new_images);
		$new_images = preg_replace("/{{height}}/i", $height_thumb, $new_images);
		if($row['thumb_type'] == "upload")
		{
			$new_images = preg_replace("/{{img}}/i", $conf['url'] . "images/thumbs/" . $row['thumb'], $new_images);
		}
		else
		{
			$new_images = preg_replace("/{{img}}/i", $row['thumb'], $new_images);
		}
	}

	if (!$DB->query("SELECT COUNT(p.pic) as pic_count, p.pic, i.* FROM " . $conf['dbprefix'] . "sent_cards p, " . $conf['dbprefix'] . "images i WHERE p.pic != 0 AND p.pic=i.id GROUP BY p.pic ORDER BY pic_count DESC LIMIT 0," . escape_string($num_new_pop_imgs) . ""))
	{
		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
	}

//	if (!$DB->query("SELECT i.*, s.pic FROM " . $conf['dbprefix'] . "sent_cards s, " . $conf['dbprefix'] . "images i WHERE s.pic=i.id GROUP BY s.pic ORDER by s.pic DESC, i.id ASC LIMIT 0," . escape_string($num_new_pop_imgs) . ""))
//	{
//		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
//	}

	//Define
	$popular_images = "";

	while($row=$DB->fetch_array())
	{

		$popular_images .= "<br />";

		$click_img ="n";
		$click_img = getMacro(getExt($row['thumb']), "click_img");

		if($click_img =="y")
		{
			$popular_images .= "<a href=\"" . $conf['script'] . "?act=form&amp;pic=" . $row['id'] . "\">";
		}

		$popular_images .= getMacro(getExt($row['thumb']), "macro");

		if($click_img =="y")
		{
			$popular_images .= "</a>";
		}


		$popular_images .= "<br /><a href=\"" . $conf['script'] . "?act=form&amp;pic=" . $row['id'] . "\">" . $row['name'] . "</a><br />";
		$popular_images = preg_replace("/{{name}}/i", $row['name'], $popular_images);
		
		//It is important to set the width and height variables to 0 each time or they will be reused between images
		$width_thumb = "";
		$height_thumb = "";
		if($row['width_thumb'] != "" && $row['width_thumb'] != "0" && $row['width_thumb'] != "NULL")
		{
			$width_thumb = "width=\"" . $row['width_thumb'] . "\"";
		}
		if($row['height_thumb'] != "" && $row['height_thumb'] != "0" && $row['height_thumb'] != "NULL")
		{
			$height_thumb = "height=\"" . $row['height_thumb'] . "\"";
		}
		$popular_images = preg_replace("/{{width}}/i", $width_thumb, $popular_images);
		$popular_images = preg_replace("/{{height}}/i", $height_thumb, $popular_images);
		
		if($row['thumb_type'] == "upload")
		{
			$popular_images = preg_replace("/{{img}}/i", $conf['url'] . "images/thumbs/" . $row['thumb'], $popular_images);
		}
		else
		{
			$popular_images = preg_replace("/{{img}}/i", $row['thumb'], $popular_images);
		}
	}

	$cat_to_show = isset($conf['cat_to_show']) ? $conf['cat_to_show'] : 6;

	//Define
	$browse_images = "";

	if(!$result = mysql_query("SELECT id FROM " . $conf['dbprefix'] . "categories ORDER by RAND() LIMIT 0," . $cat_to_show . ""))
	{
		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
	}
	while ($row = mysql_fetch_array($result))
	{
		$cq = $DB->query("SELECT c.id AS cat_id, c.title, i.name, i.thumb, i.thumb_type, i.width_thumb, i.height_thumb, i.id AS img_id
		FROM " . $conf['dbprefix'] . "images i, " . $conf['dbprefix'] . "categories c
		WHERE c.id = i.cat
		AND c.id = ${row['id']}
		ORDER by RAND()
		LIMIT 3");
		$temp_count = 1;
		while ($cr = $DB->fetch_array($cq))
		{
			if($temp_count == 1)
			{
				$browse_images .= "<table class=\"noborder\" width=\"100%\">\n";
				$browse_images .= "<tr>\n<td align=\"left\">";

				$click_img ="n";
				$click_img = getMacro(getExt($cr['thumb']), "click_img");

				if($click_img =="y")
				{
					$browse_images .= "<a href=\"" . $conf['script'] . "?act=form&amp;pic=" . $cr['img_id'] . "\">";
				}

				$browse_images .= getMacro(getExt($cr['thumb']), "macro");
				$browse_images = preg_replace("/{{name}}/i", $cr['name'], $browse_images);

				if($click_img =="y")
				{
					$browse_images .= "</a>";
				}
				
				//It is important to set the width and height variables to 0 each time or they will be reused between images
				$width_thumb = "";
				$height_thumb = "";
				if($cr['width_thumb'] != "" && $cr['width_thumb'] != "0" && $cr['width_thumb'] != "NULL")
				{
					$width_thumb = "width=\"" . $cr['width_thumb'] . "\"";
				}
				if($cr['height_thumb'] != "" && $cr['height_thumb'] != "0" && $cr['height_thumb'] != "NULL")
				{
					$height_thumb = "height=\"" . $cr['height_thumb'] . "\"";
				}
				$browse_images = preg_replace("/{{width}}/i", $width_thumb, $browse_images);
				$browse_images = preg_replace("/{{height}}/i", $height_thumb, $browse_images);
				
				if($cr['thumb_type'] == "upload")
				{
					$browse_images = preg_replace("/{{img}}/i", $conf['url'] . "images/thumbs/" . $cr['thumb'], $browse_images);
				}
				else
				{
					$browse_images = preg_replace("/{{img}}/i", $cr['thumb'], $browse_images);
				}
				$browse_images .= "</td>\n";
				$browse_images .= "<td align=\"left\" width=\"100%\" valign=\"top\"><span class=\"sub_header\">" . $cr['title'] . "</span><br />\n";
			}
				$browse_images .="<a href=\"" . $conf['script'] . "?act=form&amp;pic=" . $cr['img_id'] . "\" title=\"" . $cr['name'] . "\">" . $cr['name'] . "</a><br />\n";

			if($temp_count == 3 || $temp_count == $DB->num_rows())
			{
				$browse_images .="</td></tr></table>";
			}


			$temp_count ++;
		}
		unset($temp_count);
	}

	$page_title = $lang['browse_imgs'];

	if(!$fp = @fopen("./templates/view_image_stats.html", "r"))
	{
		error($lang['cannot_open_file'] . " <b>view_image_stats.html</b>", $lang['check_file_exists'] . "|" . $lang['cannot_file_perms']);
	}
	$data = @fread($fp, filesize("./templates/view_image_stats.html"));

	$data = preg_replace("/{{action}}/i", $conf['script'], $data);
	$data = preg_replace("/{{new_images}}/i", $new_images, $data);
	$data = preg_replace("/{{popular_images}}/i", $popular_images, $data);
	$data = preg_replace("/{{browse_images}}/i", $browse_images, $data);
	$data = preg_replace("/{{search_select_box}}/i", $search_box, $data);
	$data = preg_replace("/{{cat_jump}}/i", $cat_list, $data);
	$data = preg_replace("/{{messages}}/i", $messages, $data);
	return $data;

}

function adv_search_form($warnings="")
{
global $conf, $DB, $lang, $page_title;

	if(!$render_open = @fopen("./templates/adv_search.html", "r"))
        {
		return error($lang['cannot_open_file'] . " <b>./templates/adv_searcg.html</b>", $lang['check_file_exists'] . "|" . $lang['cannot_file_perms']);
        }
	$render = @fread($render_open, filesize("./templates/adv_search.html"));

	if (!$DB->query("SELECT id, title FROM " . $conf['dbprefix'] . "categories ORDER by title ASC"))
	{
		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
	}

	while($row=$DB->fetch_array())
	{
		$cat_list .= "<option value=\"" . $row['id'] . "\">" . $row['title'] . "</option>\n";
	}

	$page_title = $lang['search'];

	$data = preg_replace("/{{action}}/i", $conf['script'], $render);
	$data = preg_replace("/{{cat_select}}/i", $cat_list, $data);
	$data = preg_replace("/{{warnings}}/i", $warnings, $data);

	return $data;

}

function choose_image_template($warnings="", $search="no")
{
global $conf, $DB, $lang, $page_title;
$img_count = 0;

	if($search == "yes")
	{
		if($_GET['act'] == "search") // ie we are only basic searching, not advanced searching
		{
			$sql = "SELECT * FROM " . $conf['dbprefix'] . "images WHERE name LIKE '%" . escape_string($_POST['search_text']) . "%'";
			if($_POST['search_cat'] != "all" && isset($_POST['search_cat']))
			{
				$sql .= " AND cat=\"" . escape_string($_POST['search_cat']) . "\"";
			}
		}
		else	// set up sql for advanced search
		{
		
			//Check that the user has entered some words to search and chosen some categories
			if($_POST['search_terms'] == "")
			{
				return adv_search_form($lang['no_search_terms']);
			}
			if(count($_POST['cat_search']) == 0)
			{
				return adv_search_form($lang['no_cat_selected']);
			}
		
			$sql = "SELECT * FROM " . $conf['dbprefix'] . "images WHERE MATCH (name) AGAINST "; //base sql for all advanced queries
			if($_POST['match_mode'] == "any_words")
			{
				$sql .= "('" . escape_string($_POST['search_terms']) . "' IN BOOLEAN MODE)";
			}
			else if($_POST['match_mode'] == "all_words")
			{
				$word_array = explode(" ", $_POST['search_terms']);
				foreach($word_array as $word)
				{
					$word_string .= "+" . $word. " ";
				}
				$sql .= "('" . escape_string($word_string) . "' IN BOOLEAN MODE)";
			}
			else if($_POST['match_mode'] == "exact_phrase")
			{
				$sql .= "('\"" . escape_string($_POST['search_terms']) . "\"' IN BOOLEAN MODE)";
			}

			//Now set up the sql for the categories chosen
			if(!in_array("all", $_POST['cat_search'])) //ie we are NOT searching all categories, therefore must modify the sql some more
			{
				foreach($_POST['cat_search'] as $key => $cat)
				{
					if($key != "0")
					{
						$cat_sql_list .= " OR cat = '" . $cat . "'";
					}
					else
					{
						$cat_sql_list .= "cat = '" . $cat . "'";
					}
				}

				//Now put all the sql together
				$sql .= " AND (" . $cat_sql_list . ")";
			}
		}

		$page_title = $lang['search_results'];
	}

	else
	{
		if (!isset($_GET['cat']) || $_GET['cat'] == "")
		{
			$sql = "SELECT * FROM " . $conf['dbprefix'] . "images";
			$cat_name = "all categories";
		}
		else
		{
			$sql = "SELECT * FROM " . $conf['dbprefix'] . "images WHERE cat=\"" . escape_string($_GET['cat']) . "\"";
		}

		/*/////////////////////////////
		// Construct limit box and < prev | next > links
		//////////////////////////////*/

		$prev_next = "";

		//Unfortunately, we must execute another SQL query to count the total number of rows for this cat
		$DB->query($sql);
		$numrows = $DB->num_rows();

		//Ensure the values for limiting cards seen are valid to insert into DB query
		$offset = isset($_GET['offset']) && is_numeric($_GET['offset']) ? $_GET['offset'] : 0;
		$limit = isset($_GET['limit']) && is_numeric($_GET['limit']) ? $_GET['limit'] : 10;

		$limit_box = "<select name=\"limit\">\n";
		$limit_box .= "<option value=\"5\""; if ($limit == 5) { $limit_box .= " selected=\"selected\""; } $limit_box .= ">5</option>\n";
		$limit_box .= "<option value=\"10\""; if ($limit == 10) { $limit_box .= " selected=\"selected\""; } $limit_box .= ">10</option>\n";
		$limit_box .= "<option value=\"20\""; if ($limit == 20) { $limit_box .= " selected=\"selected\""; } $limit_box .= ">20</option>\n";
		$limit_box .= "<option value=\"50\""; if ($limit == 50) { $limit_box .= " selected=\"selected\""; } $limit_box .= ">50</option>\n";
		$limit_box .= "<option value=\"100\""; if ($limit == 100) { $limit_box .= " selected=\"selected\""; } $limit_box .= ">100</option>\n";
		$limit_box .= "</select>";

		if ($numrows <= $limit)
		{
			$prev_next .= $lang['1_page'];
		}
		else
		{
			$pages=intval($numrows/$limit);
			$totpages = $pages+1;
			$prev_next .= $lang['pages'];
	    		if ($offset!=0)
			{
				$prevoffset=$offset-$limit;
				$prev_next .= "<a href=\"" . $conf['script'] . "?act=browse_cat&amp;cat=" . $_GET['cat'] . "&amp;limit=$limit&amp;offset=$prevoffset\"> " . $lang['prev'] . "</a>&nbsp;\n";
   			}
   
	   		if ($numrows%$limit)
			{
				$pages++;
	   		}
			for ($i=1;$i<=$pages;$i++)
			{
				$cpage = $offset + $limit;
				$cpage = $cpage/$limit;
				if ($cpage == "$i")
				{
					$prev_next .= "<b>$i</b>&nbsp;\n";
				}
				else
				{
       					$newoffset=$limit*($i-1);
	       				$prev_next .= "<a href=\"" . $conf['script'] . "?act=browse_cat&amp;cat=" . $_GET['cat'] . "&amp;limit=$limit&amp;offset=$newoffset\">$i</a>&nbsp;\n";
				}
			}
			$cpage = $offset + $limit;
			$cpage = $cpage/$limit;
   			if ((($cpage*$limit)<=$numrows) && $pages!=1)
			{
       				$newoffset=$offset+$limit;
       				$prev_next .= "<a href=\"" . $conf['script'] . "?act=browse_cat&amp;cat=" . $_GET['cat'] . "&amp;limit=$limit&amp;offset=$newoffset\">" . $lang['next'] . "</a>\n";
   			}
		}

		if($conf['default_sort'] == "name_asc") //Sort by image name - a-z
		{
			$sql .= " ORDER by name ASC";
		}
		else if($conf['default_sort'] == "name_desc") //Sort by image name - z-a
		{
			$sql .= " ORDER by name DESC";
		}
		else if($conf['default_sort'] == "id_asc") //Sort by id - 1-10
		{
			$sql .= " ORDER by id ASC";
		}
		else
		{
			$sql .= " ORDER by id DESC";
		}


		$sql .= " LIMIT " . $offset . ", " . $limit . "";

	}

	//Define
	$img_output = "";

	if (!$DB->query($sql))
	{
		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
	}
	if($DB->num_rows() <= "0")
	{
		$img_output .= $lang['no_img_found'] . "<br /><br /><br /><br /><br /><br />";
	}
	$to_repeat = ($conf['img_per_row'] - $DB->num_rows()%$conf['img_per_row']);
	while ($row = $DB->fetch_array())
	{

		$macro = "";
		$click_img ="n";
		$click_img = getMacro(getExt($row['thumb']), "click_img");

		if($click_img =="y")
		{
			$macro .= "<a href=\"" . $conf['script'] . "?act=form&amp;pic=" . $row['id'] . "\">";
		}

		$macro .= getMacro(getExt($row['thumb']));
		$macro = preg_replace("/{{name}}/i", $row['name'], $macro);

		if($click_img =="y")
		{
			$macro .= "</a>";
		}


	
	//It is important to reset the width and height variables each time or they will be reused between images
	$width_thumb = "";
	$height_thumb = "";
	if($row['width_thumb'] != "" && $row['width_thumb'] != "0" && $row['width_thumb'] != "NULL")
	{
		$width_thumb = "width=\"" . $row['width_thumb'] . "\"";
	}
	if($row['height_thumb'] != "" && $row['height_thumb'] != "0" && $row['height_thumb'] != "NULL")
	{
		$height_thumb = "height=\"" . $row['height_thumb'] . "\"";
	}
	$macro = preg_replace("/{{width}}/i", $width_thumb, $macro);
	$macro = preg_replace("/{{height}}/i", $height_thumb, $macro);
	
	if($row['thumb_type'] == "upload")
	{
		$macro = preg_replace("/{{img}}/i", $conf['url'] . "images/thumbs/" . $row['thumb'], $macro);
	}
	else
	{
		$macro = preg_replace("/{{img}}/i", $row['thumb'], $macro);
	}

		if ($img_count%$conf['img_per_row'] == "0")
		{
			$img_output .= "<tr>";
		}
		$img_output .= "<td align=\"center\" valign=\"top\">";
		$img_output .= $macro;
		$img_output .= "<br /><a href=\"" . $conf['script'] . "?act=form&amp;pic=" . $row['id'] . "\">" . $row['name'] . "</a></td>\n";
		if ($img_count%$conf['img_per_row'] == $conf['img_per_row'] - 1 && $img_count!=$DB->num_rows())
		{
			$img_output .= "</tr>\n\n";
		}
		$img_count++;
	}
	if($to_repeat != $conf['img_per_row'])
	{
		$img_output .= str_repeat("<td>&nbsp;</td>\n", $to_repeat);		
	}

	if(isset($to_repeat) && $to_repeat > 0)
	{
		$img_output .= "</tr>";
	}

		if(!$fp = @fopen("./templates/select_img.html", "r"))
       	{
		return error($lang['cannot_open_file'] . " <b>./templates/select_img.html</b>", $lang['check_file_exists'] . "|" . $lang['cannot_file_perms']);

       	}
       	else
       	{
		$data = @fread($fp, filesize("./templates/select_img.html"));
		$recip = preg_replace("/{{choose_pic}}/i", $img_output, $data);
	}

	if (!$DB->query("SELECT id, title, description FROM " . $conf['dbprefix'] . "categories ORDER BY title ASC"))
	{
		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
	}

	$select_box = "<select name=\"search_cat\">\n
			<option value=\"all\">" . $lang['all_cats'] . "</option>";

	$cat = "<tr><td align=\"left\"><img src=\"./site_images/small_arrow.gif\" alt=\"nav\" title=\"nav\" /></td><td align=\"left\"><span class=\"cat_list\"><a href=\"" . $conf['script'] . "?act=browse_cat\" title=\"" . $lang['browse_cats'] . " - " . $lang['all_cats'] . "\">" . $lang['all_cats'] . "</a></span></td></tr>\n";
	while ($row=$DB->fetch_array())
	{
		$select_box .= "<option value=\"" . $row['id'] . "\"";
		if((isset($_GET['cat']) && $_GET['cat'] == $row['id']) || (isset($_POST['search_cat']) && $_POST['search_cat'] == $row['id']))
		{
			$select_box .= " selected=\"selected\"";
		}
		$select_box .= ">" . $row['title'] . "</option>";

		if($_GET['cat'] == "")
		{
			if($search == "yes")
			{
				$current_cat = $lang['search_results'];
			}
			else
			{
				$current_cat = $lang['all_cats'];
			}
		}
		if ($_GET['cat'] != $row['id'])
		{
			$cat .= "<tr><td align=\"left\"><img src=\"./site_images/small_arrow.gif\" alt=\"nav\" title=\"nav\" /></td><td align=\"left\"><span class=\"cat_list\"><a href=\"" . $conf['script'] . "?act=browse_cat&amp;cat=" . $row['id'] . "\" title=\"" . $lang['browse_cats'] . " - " . $row['title'] . "\">" . $row['title'] . "</a><br /></span></td></tr>\n";
		}
		else
		{
			$cat .= "<tr><td align=\"left\"><img src=\"./site_images/small_arrow.gif\" alt=\"nav\"  title=\"nav\" /></td><td align=\"left\"><b>" . $row['title'] . "</b></td></tr>\n";
			$cat .= "<tr><td align=\"left\">&nbsp;</td><td align=\"left\"><i> " . nl2br($row['description']) . "</i></td></tr>\n";
			$current_cat = $row['title'];
		}
	}
	$select_box .= "</select>";

	if($_GET['act'] == "search" || $_GET['act'] == "do_adv_search")
	{
		$start_prev_next = "<!-- \n Hide drop-box because we are searching";
		$end_prev_next = "-->";
		$search_terms = $_POST['search_text'];
	}
	else
	{
		$start_prev_next = "<!-- Drop-box to change number viewed per page -->";
		$end_prev_next = "<!-- End drop-box -->";
		$search_terms = $lang['enter_terms'];
	}

	$page_title = $lang['browse_cats'] . " - " . $current_cat;

	$recip = preg_replace("/{{cat_jump}}/i", $cat, $recip);
	$recip = preg_replace("/{{search_select_box}}/i", $select_box, $recip);
	$recip = preg_replace("/{{cat_name}}/i", $current_cat, $recip);
	$recip = preg_replace("/{{cat_id}}/i", $_GET['cat'], $recip);
	$recip = preg_replace("/{{action}}/i", $conf['script'], $recip);
	$recip = preg_replace("/{{warnings}}/i", $warnings, $recip);
	$recip = preg_replace("/{{limit_box}}/i", $limit_box, $recip);
	$recip = preg_replace("/{{prev_next_link}}/i", $prev_next, $recip);
	$recip = preg_replace("/{{start_prev_next}}/i", $start_prev_next, $recip);
	$recip = preg_replace("/{{end_prev_next}}/i", $end_prev_next, $recip);
	$recip = preg_replace("/{{search_terms}}/i", $search_terms, $recip);
	return $recip;
}

function parse_template($warnings="")
// Parses the main form and put all our variables and warnings in
{
global $conf, $DB, $lang, $page_title;

	$selected_pic = isset($_POST['pic']) ? $_POST['pic'] : $_GET['pic'];

	if (!isset($selected_pic))
	{
		return choose_image_template("<br /><br />" . $lang['please_select_image']);
	}

	$selected_pic = (int) $selected_pic;

	$define = array("title", "sender_name", "sender_email", "message");
	foreach ($define as $define)
	{
		if (!isset($_POST[$define]))
		{
			$_POST[$define] = "";
		}
	}
	// For error reporting's sake make the undefined variables blank
	// Now do recipients template
	for($i=0; $i<=($conf['max_recip'] - 1); $i++)
	{
			$recip .= "Recipient " . ($i + 1) . " email<br />";

			$recip .= "<input size=\"50\" type=\"text\" name=\"recip_email[]\" value=\"" . $_POST['recip_email'][$i] . "\" class=\"chunky\" /><br /><br />";
        }

	if($conf['enable_notify'] == "y")
	{
		$checked = $_POST['notify'] == "1" ? "checked=\"checked\" " : "";
		$notify_box = "<br /><br /><input type=\"checkbox\" name=\"notify\" id=\"notify\" value=\"1\" class=\"chunky\" " . $checked . "/> <label for=\"notify\">" . $lang['notify_when_picked'] . "</label>";
	}

	//If the user is allowed to delay the sending then let them do it here
	if($conf['delay_send'] == "y")
	{
		$delay_send = "<br /><br />" . $lang['when_send'] . "<br /><br /><input type=\"radio\"";
		if($_POST['when_send'] == "now" || $_POST['when_send'] == "")
		{
			$delay_send .= " checked=\"checked\"";
		}
		$delay_send .= " name=\"when_send\" value=\"now\"> " . $lang['send_now'] . "<br />";

		$delay_send .= "<input type=\"radio\"";
		if($_POST['when_send'] == "later")
		{
			$delay_send .= " checked=\"checked\"";
		}
		$delay_send .= " name=\"when_send\" value=\"later\"> " . $lang['send_later'] . " [ <a href=\"javascript:popCal();\" onClick=\"document.main_form.when_send[1].checked=true;\">" . $lang['open_calendar'] . "</a> ] <input type=\"text\" name=\"send_date\" id=\"send_date_box\" class=\"send_date_box\" value=\"" . $_POST['send_date'] . "\" onChange=\"document.main_form.when_send[1].checked=true;\" readonly=\"readonly\" />";
	}

	if (!$DB->query("SELECT name, url, img_type, width, height FROM " . $conf['dbprefix'] . "images WHERE id=\"" . $selected_pic . "\" LIMIT 1"))
	{
		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
	}

	while($row = $DB->fetch_array())
	{
		$macro = getMacro(getExt($row['url']), "macro");
		$macro = preg_replace("/{{name}}/i", $row['name'], $macro);
		
		//It is important to set the width and height variables to 0 each time or they will be reused between images
		$width = "";
		$height = "";
		if($row['width'] != "" && $row['width'] != "0" && $row['width'] != "NULL")
		{
			$width = "width=\"" . $row['width'] . "\"";
		}
		if($row['height'] != "" && $row['height'] != "0" && $row['height'] != "NULL")
		{
			$height = "height=\"" . $row['height'] . "\"";
		}
		$macro = preg_replace("/{{width}}/i", $width, $macro);
		$macro = preg_replace("/{{height}}/i", $height, $macro);
		
		if($row['img_type'] == "upload")
		{
			$macro = preg_replace("/{{img}}/i", $conf['url'] . "images/" . $row['url'], $macro);
		}
		else
		{
			$macro = preg_replace("/{{img}}/i", $row['url'], $macro);
		}
		$img_name = $row['name'];
	}

	//Now render the font and background options as defined in the config file
	$bg_select_array = explode(",", $conf['font_bg_colours']);
	foreach($bg_select_array as $colour)
	{
		$bg_select .= "<option style=\"background: " . $colour . ";\" value=\"" . $colour . "\"";
		if($_POST['bg_color'] == $colour)
		{
			$bg_select .= " selected=\"selected\"";
		}
		$bg_select .= ">" . $colour . "</option>\n";
	}
	$font_colour_select_array = explode(",", $conf['font_colours']);
	foreach($font_colour_select_array as $colour)
	{
		$font_colour_select .= "<option style=\"color: " . $colour . ";\" value=\"" . $colour . "\"";
		if($_POST['font_color'] == $colour)
		{
			$font_colour_select .= " selected=\"selected\"";
		}
		$font_colour_select .= ">" . $colour . "</option>\n";
	}
	$font_face_select_array = explode(",", $conf['font_faces']);
	foreach($font_face_select_array as $font)
	{
		$font_face_select .= "<option style=\"font-family:" . $font . "\"; value=\"" . $font . "\"";
		if($_POST['font_face'] == $font)
		{
			$font_face_select .= " selected=\"selected\"";
		}
		$font_face_select .= ">" . $font . "</option>\n";
	}
	$font_size_select_array = explode(",", $conf['font_sizes']);
	foreach($font_size_select_array as $size)
	{
		$font_size_select .= "<option value=\"" . $size . "\"";
		if($_POST['font_size'] == $size)
		{
			$font_size_select .= " selected=\"selected\"";
		}
		$font_size_select .= ">" . $size . "</option>\n";
	}

	if(!$fp = @fopen("./templates/main_form.html", "r"))
        {
                return error($lang['cannot_open_file'] . " <b>./templates/main_form.html</b>", $lang['check_file_exists'] . "|" . $lang['cannot_file_perms']);
        }
        else
        {

		$page_title = $img_name;

		//If the user has made a mistake and we are looking at an error page, the <br> and <br /> tags must be converted back to \n
		$_POST['message'] = preg_replace("/<br>/i", "\n", $_POST['message']);
		$_POST['message'] = preg_replace("/<br \/>/", "\n", $_POST['message']);

		$data = @fread($fp, filesize("./templates/main_form.html"));
		$data = preg_replace("/{{action}}/i", $conf['script'], $data);
		$data = preg_replace("/{{show_pic}}/i", $macro . "<br />" . $img_name, $data);
		$data = preg_replace("/{{chosen_pic}}/i", $selected_pic, $data);
		$data = preg_replace("/{{title}}/i", $_POST['title'], $data);
		$data = preg_replace("/{{sender_name}}/i", $_POST['sender_name'], $data);
		$data = preg_replace("/{{sender_email}}/i", $_POST['sender_email'], $data);
		$data = preg_replace("/{{message}}/i", $_POST['message'], $data);
		$data = preg_replace("/{{max_message_length}}/i", $conf['max_message_length'], $data);
		$data = preg_replace("/{{warnings}}/i", $warnings, $data);
		$data = preg_replace("/{{delay_send}}/i", $delay_send, $data);
		$data = preg_replace("/{{notify_box}}/i", $notify_box, $data);
		$data = preg_replace("/{{max_recip}}/i", $conf['max_recip'], $data);
		$data = preg_replace("/{{bg_select}}/i", $bg_select, $data);
		$data = preg_replace("/{{font_colour_select}}/i", $font_colour_select, $data);
		$data = preg_replace("/{{font_face_select}}/i", $font_face_select, $data);
		$data = preg_replace("/{{font_size_select}}/i", $font_size_select, $data);
		$form_output = preg_replace("/{{recipients}}/i", $recip, $data);
        }
	return $form_output;
}

function preview()
{
global $conf, $DB, $lang, $page_title;

	$required = array("title" => $lang['card_title'], "sender_name" => $lang['your_name'], "sender_email" => $lang['your_email'], "pic" => $lang['pic_2_send'], "bg_color" => $lang['bg_colour'], "font_color" => $lang['font_colour'], "font_face" => $lang['font_face'], "font_size" => $lang['font_size'], "message" => $lang['msg_2_send']);
	foreach($required as $k => $v)
	{
		$actual = $_POST[$k];
		if ($actual == "")
		{
			return parse_template($lang['val_4_field'] . " \"" . $v . "\" " . $lang['is_required']);
		}
	}
	if(!isset($_POST['sender_email']) || $_POST['sender_email'] == "")
	{
		return parse_template($lang['no_email']);
	}
	if (!check_email_format($_POST['sender_email']))
	{
		return parse_template($lang['email_ad'] . "\"" . $_POST['sender_email'] . "\"" . $lang['is_invalid']);
	}

	if (!check_email($_POST['sender_email']))
	{
		return parse_template($lang['email_ad'] . "\"" . $_POST['sender_email'] . "\"" . $lang['been_banned']);
	}


	$email_count = 0;
	for($i=0; $i<=count($_POST['recip_email']); $i++)
	{
		if (isset($_POST['recip_email'][$i]) && $_POST['recip_email'][$i] != "")
		{
			$actual = $i + 1;
			if (!check_email_format($_POST['recip_email'][$i]))
			{
				return parse_template($lang['email_recip_entered'] . $actual . ", \"" . $_POST['recip_email'][$i] . "\"" . $lang['is_invalid']);
			}
			if (!check_email($_POST['recip_email'][$i]))
			{
				return parse_template($lang['email_recip_entered'] . $actual . ", \"" . $_POST['recip_email'][$i] . "\"" . $lang['been_banned']);
			}
	
			$email_count++;
		}
	}

	if ($email_count <= 0)
	{
		return parse_template($lang['no_recips_entered']);
	}

	if($_POST['bg_color'] == $_POST['font_color'])
	{
		return parse_template($lang['bg_font_colors_match']);
	}

	//Check that mesage is not too long
	if(isset($conf['max_message_length']) && $conf['max_message_length'] != "")
	{
		if (strlen($_POST['message']) > $conf['max_message_length'])
		{
			return parse_template($lang['msg_too_long'] . $conf['max_message_length'] . " " . $lang['chars']);
		}
	}

	//Check whether the user wants to send the card on a particular date and if they have chosen a valid date.

	if($conf['delay_send'] != "y")
	{
		$_POST['when_send'] = "now";
	}

	if($_POST['when_send'] == "" || !isset($_POST['when_send']))
	{
		return parse_template($lang['invalid_date']);
	}

	if($_POST['when_send'] == "later")
	{
		//Check the date format is xxxx-x-x
		$date_pieces = explode("-", $_POST['send_date']);

		if(!isset($_POST['send_date']) || count($date_pieces) != 3)
		{
			return parse_template($lang['invalid_date']);
		}
		if(strlen($date_pieces[0]) != "4" || strlen($date_pieces[1]) > 2 || strlen($date_pieces[1]) < 1 || strlen($date_pieces[2]) > 2 || strlen($date_pieces[2]) < 1)
		{
			return parse_template($lang['invalid_date']);
		}
	}

	if(!$fp = @fopen("./templates/preview_card.html", "r"))
        {
		return error($lang['cannot_open_file'] . " <b>./templates/preview_card.html</b>", $lang['check_file_exists'] . "|" . $lang['cannot_file_perms']);
        }

	if (!$DB->query("SELECT url, img_type, width, height FROM " . $conf['dbprefix'] . "images WHERE id=\"" . escape_string($_POST['pic']) . "\" LIMIT 1"))
	{
		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
	}

	while($row = $DB->fetch_array())
	{
		$macro = getMacro(getExt($row['url']), "macro");
		$macro = preg_replace("/{{name}}/i", $row['name'], $macro);
		
		//It is important to set the width and height variables to 0 each time or they will be reused between images
		$width = "";
		$height = "";
		if($row['width'] != "" && $row['width'] != "0" && $row['width'] != "NULL")
		{
			$width = "width=\"" . $row['width'] . "\"";
		}
		if($row['height'] != "" && $row['height'] != "0" && $row['height'] != "NULL")
		{
			$height = "height=\"" . $row['height'] . "\"";
		}
		$macro = preg_replace("/{{width}}/i", $width, $macro);
		$macro = preg_replace("/{{height}}/i", $height, $macro);
		if($row['img_type'] == "upload")
		{
			$macro = preg_replace("/{{img}}/i", $conf['url'] . "images/" . $row['url'], $macro);
		}
		else
		{
			$macro = preg_replace("/{{img}}/i", $row['url'], $macro);
		}
		$img_name = $row['name'];
	}

	$hidden = "<input type=\"hidden\" name=\"title\" value=\"" . clean_value($_POST['title']) . "\" />\n";
	$hidden .= "<input type=\"hidden\" name=\"sender_name\" value=\"" . clean_value($_POST['sender_name']) . "\" />\n";
	$hidden .= "<input type=\"hidden\" name=\"sender_email\" value=\"" . clean_value($_POST['sender_email']) . "\" />\n";
	$hidden .= "<input type=\"hidden\" name=\"bg_color\" value=\"" . clean_value($_POST['bg_color']) . "\" />\n";
	$hidden .= "<input type=\"hidden\" name=\"font_color\" value=\"" . clean_value($_POST['font_color']) . "\" />\n";
	$hidden .= "<input type=\"hidden\" name=\"font_face\" value=\"" . clean_value($_POST['font_face']) . "\" />\n";
	$hidden .= "<input type=\"hidden\" name=\"font_size\" value=\"" . clean_value($_POST['font_size']) . "\" />\n";
	$hidden .= "<input type=\"hidden\" name=\"when_send\" value=\"" . clean_value($_POST['when_send']) . "\" />\n";
	$hidden .= "<input type=\"hidden\" name=\"send_date\" value=\"" . clean_value($_POST['send_date']) . "\" />\n";

	$hidden .= "<input type=\"hidden\" name=\"message\" value=\"" . clean_value($_POST['message']) . "\" />\n";

	$hidden .= "<input type=\"hidden\" name=\"notify\" value=\"" . $_POST['notify'] . "\" />\n";

	foreach($_POST['recip_email'] as $key => $val)
	{
		$hidden .= "<input type=\"hidden\" name=\"recip_email[]\" value=\"" . $val . "\" />\n";
	}
	$hidden .= "<input type=\"hidden\" name=\"pic\" value=\"" . $_POST['pic'] . "\" />\n";

	$page_title = $lang['preview_card'];

	if(!$render_open = @fopen("./templates/render_card.html", "r"))
        {
		return error($lang['cannot_open_file'] . " <b>./templates/render_card.html</b>", $lang['check_file_exists'] . "|" . $lang['cannot_file_perms']);
        }
	$render = @fread($render_open, filesize("./templates/render_card.html"));

	$output = @fread($fp, filesize("./templates/preview_card.html"));

	$output = preg_replace("/{{render}}/i", $render, $output);
	$output = preg_replace("/{{title}}/i", clean_value($_POST['title']), $output);
	$output = preg_replace("/{{pic}}/i", $macro, $output);
	$output = preg_replace("/{{message}}/i", parse_tags(clean_value($_POST['message'])), $output);
	$output = preg_replace("/{{script}}/i", $conf['script'], $output);
	$output = preg_replace("/{{hidden_elements}}/i", $hidden, $output);
	$output = preg_replace("/{{sender_name}}/i", clean_value($_POST['sender_name']), $output);
	$output = preg_replace("/{{sender_email}}/i", clean_value($_POST['sender_email']), $output);
	$output = preg_replace("/{{bg_colour}}/i", clean_value($_POST['bg_color']), $output);
	$output = preg_replace("/{{font_face}}/i", clean_value($_POST['font_face']), $output);
	$output = preg_replace("/{{font_size}}/i", clean_value($_POST['font_size']), $output);
	$output = preg_replace("/{{font_color}}/i", clean_value($_POST['font_color']), $output);
	$output = preg_replace("/{{date}}/i", date($conf['date_format']), $output);
	return $output;
}

function add_n_send()
{
global $conf, $DB, $lang;

	$recip_email_array = array();
	//This array holds all the email addresses that aren't blank to add them to the database

	$title = clean_value($_POST['title']);
	$sender_name = clean_value($_POST['sender_name']);
	$sender_email = clean_value($_POST['sender_email']);
	$message = clean_value($_POST['message']);
	$card_id = md5(uniqid(microtime()));
	$time = time();
	$notify = $_POST['notify'] == "1" ? "1" : "0";

	foreach($_POST['recip_email'] as $email)
	{
		if($email != "")
		{
			$recip_email_array[] = $email;
		}
	}

	$recip_email_string = implode(",", $recip_email_array);

	//Generate a date timestamp from the xxxx-xx-xx format date
	$date_pieces = explode("-", $_POST['send_date']);

	if($_POST['when_send'] == "later")
	{
		$date_stamp = mktime(0, 0, 0, $date_pieces['1'], $date_pieces['2'], $date_pieces['0']);
		$card_sent = "0";
	}
	else
	{
		$date_stamp = "now";
		$card_sent = "1";
	}

	if($conf['delay_send'] != "y")
	{
		$date_stamp = "now";
	}

	$insert_sql = "INSERT INTO " . $conf['dbprefix'] . "sent_cards (id, title, date, from_name, from_email, recip_email, bg_color, font_color, font_face, font_size, message, pic, notify, email_sent, num_resends, sender_ip, send_date, card_sent) VALUES (\"" . $card_id . "\", \"" . $title . "\", \"" . $time . "\", \"" . $sender_name . "\", \"" . $sender_email . "\", \"" . $recip_email_string . "\", \"" . clean_value($_POST['bg_color']) . "\", \"" . clean_value($_POST['font_color']) . "\", \"" . clean_value($_POST['font_face']) . "\", \"" . clean_value($_POST['font_size']) . "\", \"" . $message . "\", \"" . clean_value($_POST['pic']) . "\", \"" . $notify . "\", \"0\", \"0\", \"" . getip() . "\", \"" . $date_stamp . "\", \"" . $card_sent . "\")";
	if (!$DB->query($insert_sql))
	{
		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
	}
	
	
	if($_POST['when_send'] == "now")
	{
		if(!send_mail(send_card, $recip_email_array, $sender_name, $sender_email, $card_id))
		{
				return $lang['cannot_send_card']. $err_msg;
		}
		return view_stats_page($lang['card_sent'] . "<br /><br />" . $lang['recip_info']);
	}
	else
	{
		return view_stats_page($lang['card_queued_for_send']);
	}

}

function set_prefs()
{
global $lang, $conf;

	if($_POST['_lang'] != "")
	{
		$lang_to_set = $_POST['_lang'];
	}
	else if($_COOKIE['wc_lang'] != $_POST['_lang'])
	{
		$lang_to_set = $_COOKIE['wc_lang'];
	}
	else
	{
		$lang_to_set = "English";
	}
	//echo "\$lang_to_set = " . $lang_to_set . "<br />";
	//Check that it exists
	$lang_to_set = is_dir($conf['dir'] . "lang/" . $lang_to_set) ? $lang_to_set : "English";
	
	if($_POST['_style'] != "")
	{
		$style_to_set = $_POST['_style'];
	}
	else if($_COOKIE['wc_style'] != $_POST['_style'])
	{
		$style_to_set = $_COOKIE['wc_style'];
	}
	else
	{
		$style_to_set = "Default.css";
	}
	//Check that it exists
	$style_to_set = file_exists($conf['dir'] . "templates/styles/" . $style_to_set) ? $style_to_set : "Default.css";
	
	//We now need to set the two cookies. First of all we need to check whether the language and style have changed. If not, don't set that cookie
	
	//Set the cookie for 1 year
	$exp = time() + (60*60*24*365);
	
	if($_POST['_lang'] != "") //Only bother setting the cookie if the user has chosen a language
	{
		if($_COOKIE['wc_lang'] != $lang_to_set)
		{
			@setcookie("wc_lang", $lang_to_set, $exp);
		}
	}
	
	if($_POST['_style'] != "")
	{
		if($_COOKIE['wc_style'] != $style_to_set)
		{
			@setcookie("wc_style", $style_to_set, $exp);
		}
	}

	//See if we can go back to the referrer page
	if($_SERVER['HTTP_REFERER'] != "")
	{
		header("Location: " . $_SERVER['HTTP_REFERER']);
	}
	else
	{
		header("Location: index.php");
	}

}


function attempt_to_pickup()
{
global $DB, $conf, $lang;

	if (!isset($_GET['id']))
	{
		return show_pickup_form($lang['no_code']);
	}
	if (strlen($_GET['id']) != 32)
	{
		return show_pickup_form($lang['invalid_code']);
	}
	if (!is_string($_GET['id']))
	{
		return show_pickup_form($lang['invalid_code']);
	}

	if (!$DB->query("SELECT pic, title, from_email, from_name, bg_color, font_face, font_size, font_color, message, date, notify, email_sent FROM " . $conf['dbprefix'] . "sent_cards WHERE id=\"" . escape_string($_GET['id']) . "\" ORDER BY id DESC LIMIT 0,1"))
	{
		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
	}
	if ($DB->num_rows() <= 0)
	{
		return show_pickup_form($lang['card_id_invalid']);
	}

	if(!$fp = @fopen("./templates/render_card.html", "r"))
	{
		return error($lang['cannot_open_file'] . " <b>./templates/render_card.html</b>", $lang['check_file_exists'] . "|" . $lang['cannot_file_perms']);
	}

	$row = $DB->fetch_array();

	$data = @fread($fp, filesize("./templates/render_card.html"));
	$output = preg_replace("/{{title}}/i", $row['title'], $data);
	$output = preg_replace("/{{message}}/i", parse_tags($row['message']), $output);
	$output = preg_replace("/{{date}}/i", date($conf['date_format'], $row['date']), $output);
	$output = preg_replace("/{{sender_name}}/i", $row['from_name'], $output);
	$output = preg_replace("/{{bg_colour}}/i", $row['bg_color'], $output);
	$output = preg_replace("/{{font_face}}/i", $row['font_face'], $output);
	$output = preg_replace("/{{font_size}}/i", $row['font_size'], $output);
	$output = preg_replace("/{{font_color}}/i", $row['font_color'], $output);


	$chosen_pic = $row['pic'];

	//Check if a) the sender wants a notification and b) a notification has already been sent
	if($row['notify'] == "1" && $row['email_sent'] == "0")
	{
	//array($row['sender_email'])
		send_mail("send_notification", array($row['from_email']), $row['from_name'], 0, 0, $row['date']);
		if (!$DB->query("UPDATE " . $conf['dbprefix'] . "sent_cards SET email_sent=\"1\" WHERE id=\"" . escape_string($_GET['id']) . "\""))
		{
			return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
		}
	}

	if (!$DB->query("SELECT img_type, url, name, width, height FROM " . $conf['dbprefix'] . "images WHERE id=\"" . $chosen_pic . "\" ORDER BY id DESC LIMIT 1"))
	{
		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
	}

	$row = $DB->fetch_array();

	$macro = getMacro(getExt($row['url']));
	$macro = preg_replace("/{{name}}/i", $row['name'], $macro);
	
	//It is important to set the width and height variables to 0 each time or they will be reused between images
	$width = "";
	$height = "";
	if($row['width'] != "" && $row['width'] != "0" && $row['width'] != "NULL")
	{
		$width = "width=\"" . $row['width'] . "\"";
	}
	if($row['height'] != "" && $row['height'] != "0" && $row['height'] != "NULL")
	{
		$height = "height=\"" . $row['height'] . "\"";
	}
	$macro = preg_replace("/{{width}}/i", $width, $macro);
	$macro = preg_replace("/{{height}}/i", $height, $macro);
	
	if($row['img_type'] == "upload")
	{
		$macro = preg_replace("/{{img}}/i", $conf['url'] . "images/" . $row['url'], $macro);
	}
	else
	{
		$macro = preg_replace("/{{img}}/i", $row['url'], $macro);
	}


	$output = preg_replace("/{{pic}}/i", $macro, $output);
	return $output;
}

function show_pickup_form($errors="")
{
global $conf, $lang;

	$html = "<span class=\"page_header\">" . $lang['pickup_a_webcard'] . "</span><br /><br />";
	if (isset($errors))
	{
		$html .= "<span class=\"warning\">" . $errors . "</span>";
	}
	$html .= "<form action=\"" . $conf['script'] . "\" method=\"get\">\n\n";
	$html .= "<input type=\"hidden\" name=\"act\" value=\"do_pickup\" />";
	$html .= $lang['fill_in_id'] . "<br /><br />\n";
	$html .= "<input type=\"text\" name=\"id\" size=\"60\" class=\"chunky\" />\n<input type=\"submit\" value=\"" . $lang['go'] . "\" class=\"chunky\" /></form>";
	$html .= "<br />" . $lang['forgot_code'] . " <a href=\"" . $conf['script'] . "?act=show_resend_form\">" . $lang['click_forgot'] . "</a>.";
	return $html;
}

function show_resend_form($errors="")
{
global $conf, $lang;

	if($conf['enable_resends'] != "y")
	{
		return $lang['no_resends'];
	}

	$html = "<span class=\"page_header\">" . $lang['forgotten_pickup_code'] . "</span><br /><br />";
	if (isset($errors))
	{
		$html .= "<span class=\"warning\">" . $errors . "</span>";
	}
	$html .= "<form action=\"" . $conf['script'] . "?act=resend\" method=\"post\">\n\n";
	$html .= $lang['explain_pickup_procedure'] . "<br />\n";
	$html .= "<br /><input type=\"text\" name=\"email\" size=\"60\" class=\"chunky\" />\n<input type=\"submit\" value=\"" . $lang['go'] . "\" class=\"chunky\" /></form>";
	return $html;
}

function do_resend()
{
global $DB, $conf, $lang;

	if($conf['enable_resends'] != "y")
	{
		return $lang['no_resends'];
	}

	if($_POST['email'] == "")
	{
		return show_resend_form($lang['no_email']);
	}

	if (!$DB->query("SELECT id, from_name, recip_email FROM " . $conf['dbprefix'] . "sent_cards ORDER BY date DESC"))
	{
		return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
	}

	while($row = $DB->fetch_array())
	{
		$card_id = $row['id'];
		$mail_array = explode(",", strtolower($row['recip_email']));

		if(in_array(strtolower($_POST['email']), $mail_array))
		{
			//echo "send_mail(\"resend_validation\", array(" . $_POST['email'] . "), \"0\", \"0\", " . $row['id'] . ")<br />";
			send_mail("resend_validation", array($_POST['email']), "0", "0", $row['id']);
			if (!$DB->query("UPDATE " . $conf['dbprefix'] . "sent_cards SET num_resends=num_resends+1 WHERE id=\"" . $card_id . "\" LIMIT 1"))
			{
				return error($DB->error(), $lang['check_db_settings'] . "|" . $lang['check_db_on']);
			}
			return show_pickup_form($lang['reminder_sent']);
		}
	}

	return $lang['no_cards_found'] . "\"" . $_POST['email'] . "\"." . $lang['webcard_may_be_deleted'];
}


function output($what)
{
global $to_do, $cpy, $DB, $conf, $lang, $page_title;

	$what = isset($what) ? $what : $to_do;

	$DB->disconnect();

	$stats = get_stats("p");

	if(!$fp = @fopen("./templates/template.html", "r"))
	{
		error($lang['cannot_open_file'] . " <b>./templates/template.html</b>", $lang['check_file_exists'] . "|" . $lang['cannot_file_perms']);
	}
	$data = @fread($fp, filesize("./templates/template.html"));

	
	/*===============================================
	Add our chosen stylehseet
	
	How to choose which stylehseet to use:
	1. If a sheet is being previewed, use that or
	2. If choosing styles is disabled, use default stylesheet
	3. Read the cookie to see if a choice has been made or
	4. Use the Default.css sheet
	5. Check if the chosen stylesheet exists. If not, use Default.css
	================================================*/
	
	if(isset($_GET['preview_style']) && $_GET['preview_style'] != "")
	{
		$sheet_to_use = $_GET['preview_style'];
	}
	else if($conf['allow_styles'] == "n")
	{
		$sheet_to_use = "Default.css";
	}
	else if(isset($_COOKIE['wc_style']) && $_COOKIE['wc_style'] != "")
	{
		$sheet_to_use = $_COOKIE['wc_style'];
	}
	else
	{
		$sheet_to_use = "Default.css";
	}
	$sheet_to_use = file_exists($conf['dir'] . "templates/styles/" . $sheet_to_use) ? $sheet_to_use : "Default.css";

	//Define
	$lang_style_changer = "";

	if($conf['allow_styles'] == "y" || $conf['allow_langs'] == "y")
	{
		$lang_style_changer .= "<form action=\"./index.php?act=prefs\" method=\"post\">";

		if($conf['allow_langs'] == "y")
		{
			$lang_style_changer .= "<select name=\"_lang\">
			<option value=\"\">" . $lang['choose_lang'] . "</option>";

				//List available languages that the user can pick from
				$dp = opendir($conf['dir'] . "./lang");
				if(!$dp)
				{
					return error($lang['no_open_lang_dir'], $lang['check_dir_exists'] . "|" . $lang['check_dir_perms']);
				}
				while($file = readdir($dp))
				{
					if($file!="." && $file!=".." && $file!="index.html" && is_dir($conf['dir'] . "lang/" . $file))
					{
						$lang_style_changer .= "<option value=\"" . $file . "\">" . $file . "</option>";
					}
				}
				$lang_style_changer .= "</select>";
		}

		if($conf['allow_styles'] == "y")
		{
			$lang_style_changer .= "<select name=\"_style\">
				<option value=\"\">" . $lang['choose_style'] . "</option>";

					//List available stylesheets that the user can pick from
					$dp = opendir($conf['dir'] . "templates/styles");

					while($file = readdir($dp))
					{
						if($file!="." && $file!=".." && preg_match("/.css$/i", $file))
						{
							$filename_array = explode(".", $file);
							$title = $filename_array['0'];
							$lang_style_changer .= "<option value=\"" . $file . "\">" . $title . "</option>\n";
						}
					}
			$lang_style_changer .= "</select>
			<input type=\"submit\" value=\"  " . $lang['go'] . "  \" />";
		}

		$lang_style_changer .= "</form>";
	}

	if($page_title != "")
	{
		$page_title = " - " . $page_title;
	}

	$script_output = preg_replace("/{{content}}/i", $what, $data);
	$script_output = preg_replace("/{{chosen_style}}/i", $sheet_to_use, $script_output);
	$script_output = preg_replace("/{{page_title}}/i", $page_title, $script_output);
	$script_output = preg_replace("/{{lang_style_changer}}/i", $lang_style_changer, $script_output);
	$script_output = preg_replace("/{{debug_stats}}/i", $stats['debug_stats'], $script_output);
	$script_output = preg_replace("/{{sql_stats}}/i", $stats['sql_stats'], $script_output);
	$script_output = preg_replace("/{{get_post_stats}}/i", $stats['get_post_stats'] . $cpy, $script_output);
	$script_output = preg_replace("/{{index_charset}}/i", $lang['charset'], $script_output);

	$script_output = preg_replace("/\|\|(\w+)\|\|/ie", "stripslashes(\$lang['\$1'])", $script_output);

	echo $script_output;
	exit();
}

//If we have made it all the way to the end without any errors, output the final response
output($to_do);

?>