<?php

// +----------------------------------------------------------------------------------+
// | WebCards Version 1.1 - A powerful, easy to configure e-card system               |
// | Copyright (C) 2003 - 2006  Chris Charlton (corbyboy@hotmail.com)                 |
// |                                                                                  |
// |     This program is free software; you can redistribute it and/or modify         |
// |     it under the terms of the GNU General Public License as published by         |
// |     the Free Software Foundation; either version 2 of the License, or            |
// |     (at your option) any later version.                                          |
// |                                                                                  |
// |     This program is distributed in the hope that it will be useful,              |
// |     but WITHOUT ANY WARRANTY; without even the implied warranty of               |
// |     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                |
// |     GNU General Public License for more details.                                 |
// |                                                                                  |
// |     You should have received a copy of the GNU General Public License            |
// |     along with this program; if not, write to the Free Software                  |
// |     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    |
// |                                                                                  |
// | Authors: Chris Charlton <chris.charlton@gmail.com>                               |
// | Official Homepage: http://www.mywebcards.net                                     |
// | Project Homepage: http://www.sourceforge.net/projects/webcards                   |
// +----------------------------------------------------------------------------------+
//

?>

<html>
<head>
<title>WebCards Calendar</title>

<script language="javascript" type="text/javascript">
function sendDate(year, month, day)
{
	window.opener.document.main_form.send_date.value=''+year+'-'+month+'-'+day+'';
	self.close();
}
</script>

<?php



	/*===============================================
	Add our chosen stylehseet
	
	How to choose which stylehseet to use:
	1. If a sheet is being previewed, use that or
	2. If choosing styles is disabled, use default stylesheet
	3. Read the cookie to see if a choice has been made or
	4. Use the Default.css sheet
	5. Check if the chosen stylesheet exists. If not, use Default.css
	================================================*/
	
	if(isset($_GET['preview_style']) && $_GET['preview_style'] != "")
	{
		$sheet_to_use = $_GET['preview_style'];
	}
	else if($conf['allow_styles'] == "n")
	{
		$sheet_to_use = "Default.css";
	}
	else if(isset($_COOKIE['wc_style']) && $_COOKIE['wc_style'] != "")
	{
		$sheet_to_use = $_COOKIE['wc_style'];
	}
	else
	{
		$sheet_to_use = "Default.css";
	}
	$sheet_to_use = file_exists($conf['dir'] . "../templates/styles/" . $sheet_to_use) ? $sheet_to_use : "Default.css";


	echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"../templates/styles/" . $sheet_to_use . "\" />";

?>
</head>

<body>

<div align="center">

<?php
/***************************************
 * Script: calendar
 * Author: Indrek Pri @ indrek.eu
 * Website: www.indrek.eu
 ***************************************/

 function calendar(){

// ENG
    $name_days = array(1=>'M','T','W','T','F','S','S');
    $name_months = array(1=>'January','February','March','April','May','June','July','August','September','October','November','December');
// FIN
//    $name_days = array(1=>'M','T','K','T','P','L','S');
//    $name_months = array(1=>'Tammikuu','Helmikuu','Maaliskuu','Huhtikuu','Toukokuu','Keskuu','Heinkuu','Elokuu','Syyskuu','Lokakuu','Marraskuu','Joulukuu');
// EST
//    $name_days = array(1=>'E','T','K','N','R','L','P');
//    $name_months = array(1=>'Jaanuar','Veebruar','Mrts','Aprill','Mai','Juuni','Juuli','August','September','Oktoober','November','Detsember');

if(!isset($_GET['year']))
{
    $c_year = date("Y");
}
else
{
    $c_year = $_GET['year'];
}

if(!isset($_GET['month']))
{
    $c_month = date("m");
}
else
{
    $c_month = $_GET['month'];
}


    $first_weekday = date("w",mktime(0,0,0,$c_month,1,$c_year));
    $first_weekday = ($first_weekday==0?7:$first_weekday);

    $days_in_month = date("t", mktime (0,0,0,$c_month,1,$c_year));


    $previous_month = ($c_month-1);
    $previous_year = $c_year;
    if($previous_month == 0){
      $previous_month = '12';
      $previous_year = ($c_year-1);
}
   
    $next_month = ($c_month+1);
    $next_year = $c_year;
    if($next_month == '13'){
      $next_month = '1';
      $next_year = ($c_year+1);
}


    $calendar_body .= '<table class="noborder" border="0" cellspacing="1" cellpadding="5">';
    $calendar_body .= '<tr><td colspan="7" align="center" valign="middle" class="cal_day"><a class="cal_link" href="calendar.php?month=' . $previous_month . '&year=' . $previous_year . '">&lt;&lt;</a> '.$name_months[(int)$c_month].' '.$c_year.' <a class="cal_link" href="calendar.php?month=' . $next_month . '&year=' . $next_year . '">&gt;&gt;</a></td></tr>';

    $calendar_body .= '<tr>';
    for($i=1;$i<=7;$i++) $calendar_body .= '<td align="center" valign="middle" class="cal_day">'.$name_days[$i].'</td>';
    $calendar_body .= '</tr>';

    for($i=1;$i<=$days_in_month;){
        $calendar_body .= '<tr>';
        for($ii=1;$ii<=7;$ii++){
            if($ii==$first_weekday AND $i==1) $go = TRUE;
            elseif($i > $days_in_month ) $go = FALSE;

            if($go) $calendar_body .= '<td align="center" valign="middle" class="'.(date("Ymd", mktime (0,0,0,$c_month,$i,$c_year))==date("Ymd")?'cal_today':'cal_day').'"><a href="javascript:sendDate(\'' . $c_year . '\',\'' . $c_month . '\',\'' . $i . '\')";>'.$i++.'</a></td>';
            else $calendar_body .= '<td class="cal_day">&nbsp;</td>';
        }
        $calendar_body .= '</tr>';
    }
    $calendar_body .= '</table>';

    return $calendar_body;
}

echo calendar();

?> 


</div>

</body>
</html>